#include <stdint.h>

#define Q 7681
#define LOW ((1U << 13) - 1)
#define MONT 4088U
#define F ((MONT * (Q-1) % Q) * ((Q-1) >> 8) % Q)

const uint16_t _16xqinv[16] asm ("_16xqinv") __attribute__((aligned(32))) = {57857, 57857, 57857, 57857, 57857, 57857, 57857, 57857, 57857, 57857, 57857, 57857, 57857, 57857, 57857, 57857};
const uint16_t _16xq[16] asm ("_16xq") __attribute__((aligned(32))) = {Q, Q, Q, Q, Q, Q, Q, Q, Q, Q, Q, Q, Q, Q, Q, Q};
const uint16_t _16x2q[16] asm ("_16x2q") __attribute__((aligned(32))) = {2*Q, 2*Q, 2*Q, 2*Q, 2*Q, 2*Q, 2*Q, 2*Q, 2*Q, 2*Q, 2*Q, 2*Q, 2*Q, 2*Q, 2*Q, 2*Q};
const uint16_t _low_mask[16] asm ("_low_mask") __attribute__((aligned(32))) = {LOW, LOW, LOW, LOW, LOW, LOW, LOW, LOW, LOW, LOW, LOW, LOW, LOW, LOW, LOW, LOW};
const  uint8_t _vpshufb_idx[32] asm ("_vpshufb_idx") __attribute__((aligned(32))) = {2, 3, 0, 1, 6, 7, 4, 5, 10, 11, 8, 9, 14, 15, 12, 13, 2, 3, 0, 1, 6, 7, 4, 5, 10, 11, 8, 9, 14, 15, 12, 13};
